#!/usr/bin/python

import sys, socket, math, traceback, random, copy, pickle
import traceback
import polje

class Socket:
	__slots__ = ["sock", "buf", "tocke"]
	
	def __init__(self): self.sock = None; self.buf = ""; self.tocke = 0.0
	def create(self, sock): self.sock = sock; self.buf = ""
	def listen(self, port):
		try:
			self.sock = socket.socket(socket.AF_INET)
			self.sock.bind(('',port))
			self.sock.listen(2)
		except: raise Exception("Napaka pri cakanju na povezave")
	def accept(self):
		try:
			s = Socket()
			s.create(self.sock.accept()[0])
			s.writeline("StiriVVrsto server v.0.1py")
			return s
		except: raise Exception("Napaka pri sprejemanju povezave")
	def connect(self, hostName, port):
		try:
			self.sock = socket.socket(socket.AF_INET)
			self.sock.connect((hostName, port))
		except: raise Exception("Prijava na streznik neuspesna")
		self.buf = ""
		#
		server = sock.readline()
		print "%s" % server
		sock.writeline("AVE %s" % (Tekmovalec.ime))
		succ = sock.readline()
		if succ != "PRIJAVA USPESNA": raise Exception("Prijava na streznik neuspesna: %s" % succ)
	def close(self):
		if self.sock: self.sock.close()
	def readline(self):
		while True:
			i = self.buf.find('\n')
			if i >= 0: 
				line = self.buf[:i].strip()
				self.buf = self.buf[i + 1:]
				return line
			try: s = self.sock.recv(1024)
			except: raise Exception("Napaka pri komunikaciji s streznikom")
			if not s: raise Exception("Streznik je zaprl povezavo")
			self.buf += s
	def writeline(self, line): self.sock.send(line + "\n")
	def zbudi(self, w, h, b):
		self.writeline('ZBUDI_SE ' + str(w) + ' ' + str(h) + ' ' + str(b))
	def konec(self, razlog):
		self.writeline('KONEC_IGRE ' + str(razlog))
		if razlog == 1: self.tocke += 1
		elif razlog == 3: self.tocke += 0.5
	def adijo(self):
		self.writeline('ADIJO')

def diag_chk(w):
	return ((w[0][0] and w[1][1] and w[2][2] and w[3][3]) or (w[3][0] and w[2][1] and w[1][2] and w[0][3]))

def lin_chk(w):
	return w[0] and w[1] and w[2] and w[3]

def preveri(polje, W, H, barva):
	for x in range(W-4+1):
		for y in range(H-4+1):
			win = [[w == barva for w in q[y:(y+4)]] for q in polje[x:(x+4)]]
			if diag_chk(win): return barva
	for x in range(W-4+1):
		for y in range(H):
			win = [q[y] == barva for q in polje[x:(x+4)]]
			if lin_chk(win): return barva
	for x in range(W):
		for y in range(H-4+1):
			win = [q == barva for q in polje[x][y:(y+4)]]
			if lin_chk(win): return barva
	return False

def run_game(clients, W, H, imeni, db, swap):
	if swap: crni,beli = clients
	else: beli,crni = clients

	beli.zbudi(W, H, 0)	# 0 = zacne
	crni.zbudi(W, H, 1)

	beli.readline()	# BUDEN
	crni.readline()
	
	q = polje.Polje(sirina=W, visina=H)
	
	prejsna = -1
	for korak in xrange(W*H):
		if korak % 2 == 0: trenutni = beli; cb = 1	# 1 = bela/prvi
		else: trenutni = crni; cb = -1			#-1 = crna/drugi
		
		trenutni.writeline("QV " + str(prejsna))
		R = trenutni.readline().split(' ')
		st = int(R[1])
		
		q.dodaj(st, cb)
		#q.izpisi()
		z = preveri(q.p, q.sirina, q.visina, cb)
		
		if z == 1:
			beli.konec(1)
			crni.konec(2)
			return
		elif z == -1:
			beli.konec(2)
			crni.konec(1)
			return

		prejsna = st

	beli.konec(3)
	crni.konec(3)

def ack(cli, seq):
	r = cli.readline()
	cli.writeline('PRIJAVA USPESNA')
	print seq, "igralec je", r[4:]
	return r[4:]

def main():
	print "4-v-vrsto testni streznik, razlicica $Rev: 1599 $"
	if len(sys.argv) < 4: 
		print "Sintaksa:  python SVVEval_cli.py SteviloParovIger SirinaIgrisca VisinaIgrisca"
		print "Na primer: python SVVEval_cli.py 5 7 6"
		return

	print "Cakam na oba igralca..."
	
	random.seed()
	ls = Socket()
	ls.listen(1177)
	clients = [ls.accept(), ls.accept()]
	
	c0 = ack(clients[0], "Prvi")
	c1 = ack(clients[1], "Drugi")

	imeni = [c0, c1]

	for i in xrange(2 * int(sys.argv[1])):
		run_game(clients, int(sys.argv[2]), int(sys.argv[3]), imeni, None, i % 2 == 1)
#		print "%d %d" % (tocke[0] - tocke[1], clients[0].tocke - clients[1].tocke)
#		print "%d" % (clients[0].tocke - clients[1].tocke)
		print "Tocke: %s=%d, %s=%d, razlika=%d" % (imeni[0], clients[0].tocke, imeni[1], clients[1].tocke, clients[0].tocke - clients[1].tocke)
		
	clients[0].adijo()
	clients[1].adijo()

if __name__ == "__main__": main()
